"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StringBuilder = void 0;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

function _classPrivateFieldInitSpec(obj, privateMap, value) { _checkPrivateRedeclaration(obj, privateMap); privateMap.set(obj, value); }

function _checkPrivateRedeclaration(obj, privateCollection) { if (privateCollection.has(obj)) { throw new TypeError("Cannot initialize the same private elements twice on an object"); } }

function _classPrivateFieldSet(receiver, privateMap, value) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "set"); _classApplyDescriptorSet(receiver, descriptor, value); return value; }

function _classApplyDescriptorSet(receiver, descriptor, value) { if (descriptor.set) { descriptor.set.call(receiver, value); } else { if (!descriptor.writable) { throw new TypeError("attempted to set read only private field"); } descriptor.value = value; } }

function _classPrivateFieldGet(receiver, privateMap) { var descriptor = _classExtractFieldDescriptor(receiver, privateMap, "get"); return _classApplyDescriptorGet(receiver, descriptor); }

function _classExtractFieldDescriptor(receiver, privateMap, action) { if (!privateMap.has(receiver)) { throw new TypeError("attempted to " + action + " private field on non-instance"); } return privateMap.get(receiver); }

function _classApplyDescriptorGet(receiver, descriptor) { if (descriptor.get) { return descriptor.get.call(receiver); } return descriptor.value; }

var _value = /*#__PURE__*/new WeakMap();

var StringBuilder = /*#__PURE__*/function () {
  function StringBuilder(initialValue) {
    _classCallCheck(this, StringBuilder);

    _classPrivateFieldInitSpec(this, _value, {
      writable: true,
      value: ""
    });

    _classPrivateFieldSet(this, _value, initialValue || ""); // in case null is passed

  }
  /** Append a string to the current instance.
   *  @param {string} str the string to append.
   *  @return {this} the current instance so additional calls can be chained. */


  _createClass(StringBuilder, [{
    key: "hasValue",
    get: function get() {
      return _classPrivateFieldGet(this, _value).length > 0;
    }
  }, {
    key: "length",
    get: function get() {
      return _classPrivateFieldGet(this, _value).length;
    }
  }, {
    key: "append",
    value: function append(str) {
      _classPrivateFieldSet(this, _value, "".concat(_classPrivateFieldGet(this, _value)).concat(str));

      return this;
    }
    /** Prepend a string to the current instance.
     *  @param {string} str the string to prepend.
     *  @return {this} the current instance so additional calls can be chained. */

  }, {
    key: "prepend",
    value: function prepend(str) {
      _classPrivateFieldSet(this, _value, "".concat(str).concat(_classPrivateFieldGet(this, _value)));

      return this;
    }
    /** Append a string to the current instance at a specific index.
     *  @param {string} str the string to prepend.
     *  @return {this} the current instance so additional calls can be chained. */

  }, {
    key: "insertAt",
    value: function insertAt(start, value) {
      var _v = _classPrivateFieldGet(this, _value);

      _classPrivateFieldSet(this, _value, "".concat(_v.substring(0, start)).concat(value).concat(_v.substring(start)));

      return this;
    }
    /** Find and replace text in the current instance using either a string
     *  value or RegExp.
     *  @param {string | RegExp} match the string or regexp to use for matches.
     *  @return {this} the current instance so additional calls can be chained. */

  }, {
    key: "replace",
    value: function replace(match, replacement) {
      if (match instanceof RegExp) _classPrivateFieldSet(this, _value, _classPrivateFieldGet(this, _value).replace(match, replacement));else _classPrivateFieldSet(this, _value, _classPrivateFieldGet(this, _value).split(match).join(replacement));
      return this;
    }
    /** Clears the current instance.
     *  @return the current instance so additional calls can be chained. */

  }, {
    key: "clear",
    value: function clear() {
      _classPrivateFieldSet(this, _value, "");

      return this;
    }
    /** Copy the current instance. */

    /** @return a new StringBuilder instance with the current value */

  }, {
    key: "copy",
    value: function copy() {
      return new StringBuilder(_classPrivateFieldGet(this, _value));
    }
    /** @return the current value of this instance. */

  }, {
    key: "toString",
    value: function toString() {
      return _classPrivateFieldGet(this, _value);
    }
  }]);

  return StringBuilder;
}();

exports.StringBuilder = StringBuilder;
//# sourceMappingURL=StringBuilder.js.map